#!/bin/sh

##delete space from configure file
sed s/[[:space:]]//g drv.conf > .drv.conf

##get parameters from configure file
rx_stream_num=$(awk 'BEGIN {FS="="} /max_recvbuf_num/ {print $2}' .drv.conf)
rx_stream_buf_size=$(awk 'BEGIN {FS="="} /max_recvbuf_size/ {print $2}' .drv.conf)
tx_stream_num=$(awk 'BEGIN {FS="="} /max_sendbuf_num/ {print $2}' .drv.conf)
tx_stream_buf_size=$(awk 'BEGIN {FS="="} /max_sendbuf_size/ {print $2}' .drv.conf)
use_protostk=$(awk 'BEGIN {FS="="} /use_protostk/ {print $2}' .drv.conf)
port4send=$(awk 'BEGIN {FS="="} /port4send/ {print $2}' .drv.conf)

for ((i = 0; i < $rx_stream_num; i++)); do
    param[$i]=$(awk 'BEGIN {FS="->"} $1==INDEX {print $2}' INDEX=$i .drv.conf)
done

##check parameter's legality
if [ \( $rx_stream_num -eq 64 -o $tx_stream_num -eq 32 \) -a $use_protostk -eq 1 ]; then
    echo -n "WARING: enable use_protostk must under this situation, " 
    echo "rx_stream_num should be less than 64 and tx_stream_num should be less than 32."
    echo "driver installation failed!"
    exit
fi

##initialization rt string and div string
rt_str="rx_stream_num=$rx_stream_num rx_stream_buf_size=$rx_stream_buf_size \
tx_stream_num=$tx_stream_num tx_stream_buf_size=$tx_stream_buf_size \
use_protostk=$use_protostk port4send=$port4send"
div_str="divided_mod_param="
for ((i = 0; i < $rx_stream_num; i++)); do
    div_str="$div_str${param[$i]}"
    if [ $[i+1] -ne $rx_stream_num ]; then
        div_str="$div_str"","
    fi
done

##uninstall driver
rm -f /lib/modules/`uname -r`/kernel/drivers/net/netfirm.ko
/sbin/lsmod | grep -q "\<netfirm\>"
if [ "$?" = "0" ]; then
    modprobe -r netfirm
fi

##set auto run
grep -q "\<netfirm\>" /etc/modprobe.conf
if [ "$?" = "0" ]; then
    sed -i '/netfirm/d' /etc/modprobe.conf
fi
echo "options netfirm $rt_str $div_str" >> /etc/modprobe.conf

##install driver
/sbin/insmod netfirm.ko $rt_str $div_str
cp -f netfirm.ko /lib/modules/`uname -r`/kernel/drivers/net/
