#!/bin/sh 

LIBDIR=/usr/lib64
if [ ! -d $LIBDIR ];then
   LIBDIR=/usr/lib
fi
INCLUDEDIR=/usr/include

BOOTPATH=$(awk '
    /Red/ {print "/etc/rc.d/rc.local"}
    /GreatTurbo/ {print "/etc/rc.d/rc.local"}
    /SUSE/ {print "/etc/init.d/boot.local"}
    ' /etc/issue)
if test -z "$BOOTPATH"; then
    BOOTPATH="/etc/rc.d/rc.local"
fi
########################################
if [ "$#" == "0" ]; then

echo "installing pcap ......"

cp -f libpcap/libpcap.so $LIBDIR
cp -f libpcap/libpcap.a $LIBDIR
cp -rf include/pcap $INCLUDEDIR
cp -f include/pcap/pcap.h $INCLUDEDIR
cp -f include/pcap-bpf.h $INCLUDEDIR
cp -f include/pcap-namedb.h $INCLUDEDIR
mkdir -p /etc/netfirm
cp -f ./pcap_samples/nf0.conf /etc/netfirm/pag0.conf

echo "installing pag ......"

cp -f include/libpag.h $INCLUDEDIR
cp -f libpag/libpag.so $LIBDIR

mkdir -p /var/pagcard
mkdir -p /pag
mkdir -p /pag/lib
mkdir -p /pag/sample

cp -rf doc /pag/doc
cp -rf driver /pag/
cp -rf include /pag/
cp -rf sbin /pag/
cp -rf tools /pag/
cp -f libpag/* /pag/lib/
cp -f libpcap/* /pag/lib/
cp -f pag_samples/* /pag/sample

echo "installing driver ......"

/sbin/lsmod | grep -q "dawningmem"
if [ "$?" = "0" ]; then
    /sbin/rmmod dawningmem
    rm -rf /dev/dawningmem
fi
/sbin/insmod driver/dawningmem.ko
mknod /dev/dawningmem c `awk '$2 == "dawningmem" {print $1}' /proc/devices` 0

grep -q "dawningmem.ko" $BOOTPATH
if [ "$?" = "0" ]; then
    sed -i '/dawningmem/d' $BOOTPATH
fi
echo "/sbin/insmod /pag/driver/dawningmem.ko" >> $BOOTPATH
echo "major=\$(awk \"\\\$2 == \\\"dawningmem\\\" {print \\\$1}\" /proc/devices)" >> $BOOTPATH
echo "mknod /dev/dawningmem c \$major 0" >> $BOOTPATH
echo "dawningmem install ok"

/sbin/lsmod | grep -q "zywk"
if [ "$?" = "0" ]; then
    rm -rf /lib/modules/`uname -r`/kernel/drivers/net/zywk.ko
    modprobe -r zywk
    depmod
    sed -i '/zywk/d' /etc/modprobe.conf
fi

cp -f driver/netfirm.ko /lib/modules/`uname -r`/kernel/drivers/net/
cd driver;sh updrv.sh;cd ../
depmod
modprobe netfirm
echo "netfirm install ok"

echo "setting some parameters ......"

declare -i maxshm=68719476736
grep -q "maxshm" $BOOTPATH
if [ "$?" = "0" ]; then
    sed -i '/maxshm/d' $BOOTPATH
fi
echo $maxshm > /proc/sys/kernel/shmmax
echo "declare -i maxshm=68719476736" >> $BOOTPATH
echo "echo \$maxshm > /proc/sys/kernel/shmmax" >> $BOOTPATH
echo "parameters setting ok"

########################################
elif [ "$1" == "oem" ]; then

echo "First : install pcap"

cp -f libpcap/libpcap.so $LIBDIR
cp -f libpcap/libpcap.a $LIBDIR
cp -rf include/pcap $INCLUDEDIR
cp -f include/pcap/pcap.h $INCLUDEDIR
cp -f include/pcap-bpf.h $INCLUDEDIR
cp -f include/pcap-namedb.h $INCLUDEDIR
mkdir -p /etc/sap
cp -f ./pcap_samples/sap0.conf /etc/sap/pag0.conf

echo "Second : install pag"

cp -f include/libpag.h $INCLUDEDIR
cp -f libpag/libpag.so $LIBDIR

mkdir -p /var/pagcard
mkdir -p /pag
mkdir -p /pag/lib
mkdir -p /pag/sample

cp -rf doc /pag/doc
cp -rf driver /pag/
cp -rf include /pag/
cp -rf sbin /pag/
cp -f tools/nf_update /pag/sbin/update
cp -f tools/update.conf /pag/sbin/update.conf
cp -f libpag/* /pag/lib/
cp -f libpcap/* /pag/lib/
cp -f pag_samples/* /pag/sample

echo "Third : install driver"

cp -f driver/sap.ko /lib/modules/`uname -r`/kernel/drivers/net/
depmod
modprobe sap
echo "---sap install completed"

/sbin/lsmod | grep -q "sapmem"
if [ "$?" = "0" ]; then
    /sbin/rmmod sapmem
    rm -rf /dev/sapmem
fi
/sbin/insmod driver/sapmem.ko
mknod /dev/sapmem c `awk '$2 == "sapmem" {print $1}' /proc/devices` 0

grep -q "sapmem.ko" $BOOTPATH
if [ "$?" = "0" ]; then
    sed -i '/sapmem/d' $BOOTPATH
fi
echo "/sbin/insmod /pag/driver/sapmem.ko" >> $BOOTPATH
echo "major=\$(awk \"\\\$2 == \\\"sapmem\\\" {print \\\$1}\" /proc/devices)" >> $BOOTPATH
echo "mknod /dev/sapmem c \$major 0" >> $BOOTPATH
echo "---sapmem install completed"

echo "Last : set some parameters"

declare -i maxshm=68719476736
grep -q "maxshm" $BOOTPATH
if [ "$?" = "0" ]; then
    sed -i '/maxshm/d' $BOOTPATH
fi
echo $maxshm > /proc/sys/kernel/shmmax
echo "declare -i maxshm=68719476736" >> $BOOTPATH
echo "echo \$maxshm > /proc/sys/kernel/shmmax" >> $BOOTPATH
echo "---parameters setting completed"

########################################
else

echo "Error: shell script parameter invalid!"

fi
