#! /bin/sh
RESULT_PATH=/tmp/netfirm.result

function usage()
{
    echo "Usage: $0 <port_start> <port_end> <mac_type> <test_time_min> <ip_pkt_len> <rule_type>"
    echo "  port_start, test stable from this port, value = 0~3"
    echo "  port_end, test stable end this port, value = 0~3"
    echo "  mac_port, port type, 0 means GE, 1 means 10GE, 2 means 2.5GPOS, 3 means 10GPOS"
    echo "  test time in minutes"
    echo "  ip pkt lenth, 0 or 40~1500, 0 is random"
    echo "  rule type, 0 or 2, 0 means not checking rule filter, 2 checking rule filter"
    exit 0
}

function set_mac_type()
{
    if [ "$1" = "0" ]; then
        sed -i "s/^#\{,1\}mac_type\s*=\s*[0-3]/mac_type = $1/" pag.conf
    elif [ "$1" = "1" ]; then
        sed -i "s/^#\{,1\}mac_type\s*=\s*[0-3]/mac_type = $1/" pag.conf
    elif [ "$1" = "2" ]; then
        sed -i "s/^#\{,1\}mac_type\s*=\s*[0-3]/mac_type = $1/" pag.conf
    elif [ "$1" = "3" ]; then
        sed -i "s/^#\{,1\}mac_type\s*=\s*[0-3]/mac_type = $1/" pag.conf
    else
        usage
    fi
}

function set_rule_type()
{
    if [ "$1" = "0" ]; then
        sed -i 's/^#\{,1\}usefilterrule\s*=\s*[0-1]/usefilterrule = 0/' pag.conf
    elif [ "$1" = "2" ]; then
        sed -i 's/^#\{,1\}usefilterrule\s*=\s*[0-1]/usefilterrule = 1/' pag.conf
    else
        usage
    fi
}

function test_port()
{
    min=$3
    for ((i = $1; i <= $2; i++)); do
        sed -i "s/^#\{,1\}LogSendDevice\s*=\s*pag0:[0-9]/LogSendDevice = pag0:$i/" sendlog.conf
        sed -i "s/^#\{,1\}RstSendDevice\s*=\s*pag0:[0-9]/RstSendDevice = pag0:$i/" sendlog.conf
        sed -i "s/^#\{,1\}MacSendDevice\s*=\s*pag0:[0-9]/MacSendDevice = pag0:$i/" sendlog.conf
        ./test_stable -m $min -l $4 -t $5
        if [ "$?" = "1" ]; then
            echo ""
            echo "test stable failed in port: $i"
            min=1
        fi
    done
}

##check parameter
if [ "$#" != "6" ]; then
    usage
fi

##make file
cd pag_samples/
make clean
make

##delete tmp file
rm -rf $RESULT_PATH

##assign port type depended on mac type
set_mac_type $3

##assign usefilterrule depended on rule type
set_rule_type $6

##test stable from port_start to port_end
test_port $1 $2 $4 $5 $6

