#!/bin/sh 

LIBDIR=/usr/lib64
if [ ! -d $LIBDIR ];then
   LIBDIR=/usr/lib
fi
INCLUDEDIR=/usr/include

BOOTPATH=$(awk '
    /Red/ {print "/etc/rc.d/rc.local"}
    /GreatTurbo/ {print "/etc/rc.d/rc.local"}
    /SUSE/ {print "/etc/init.d/boot.local"}
    ' /etc/issue)
if test -z "$BOOTPATH"; then
    BOOTPATH="/etc/rc.d/rc.local"
fi

########################################
if [ "$#" == "0" ]; then

echo "uninstalling pcap ......"

rm -rf $LIBDIR/libpcap.so $LIBDIR/libpcap.a
rm -rf $INCLUDEDIR/pcap $INCLUDEDIR/pcap.h
rm -rf $INCLUDEDIR/pcap_bpf.h $INCLUDEDIR/pcap_namedb.h

echo "uninstalling pag ......"

rm -f $INCLUDEDIR/libpag.h 
rm -f $LIBDIR/libpag.so 

rm -rf /var/pagcard
rm -rf /pag
rm -rf /etc/netfirm/

echo "uninstalling driver ......"

rm -f /lib/modules/`uname -r`/kernel/drivers/net/netfirm.ko
modprobe -r netfirm
depmod
echo "netfirm uninstall ok"

/sbin/rmmod dawningmem
rm -rf /dev/dawningmem
sed -i '/dawningmem/d' $BOOTPATH
echo "dawningmem uninstall ok"

echo "uninstalling some parameters ......"
sed -i '/maxshm/d' $BOOTPATH
echo "parametes uninstall ok"

########################################
elif [ "$1" == "oem" ]; then

echo "First : uninstall pcap"

rm -rf $LIBDIR/libpcap.so $LIBDIR/libpcap.a
rm -rf $INCLUDEDIR/pcap $INCLUDEDIR/pcap.h
rm -rf $INCLUDEDIR/pcap_bpf.h $INCLUDEDIR/pcap_namedb.h

echo "Second : uninstall pag"

rm -f $INCLUDEDIR/libpag.h 
rm -f $LIBDIR/libpag.so 

rm -rf /var/pagcard
rm -rf /pag
rm -rf /etc/sap/

echo "Third : uninstall driver"

rm -f /lib/modules/`uname -r`/kernel/drivers/net/sap.ko
modprobe -r sap
depmod
echo "---sap uninstall completed"

/sbin/rmmod sapmem
rm -rf /dev/sapmem
sed -i '/sapmem/d' $BOOTPATH
echo "---sapmem uninstall completed"

echo "Last : uninstall some parameters"
sed -i '/maxshm/d' $BOOTPATH
echo "---parameters uninstall completed"

########################################
else

echo "Error: shell script parameter invalid!"

fi
